package com.test.moible.utils;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.List;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;


/**
 * 
 * @author wudy
 *
 */
public class HttpsClientUtil {

	/**
	 * SSL閮ㄥ垎鐨勫鐞�
	 * 
	 * @param httpClient
	 * @throws NoSuchAlgorithmException
	 * @throws KeyManagementException
	 */
	public static void SecurityProcess(DefaultHttpClient httpClient) throws NoSuchAlgorithmException, KeyManagementException {
		TrustManager easyTrustManager = new X509TrustManager() {
			public void checkClientTrusted(
					java.security.cert.X509Certificate[] x509Certificates,
					String s) throws java.security.cert.CertificateException {
			}

			public void checkServerTrusted(
					java.security.cert.X509Certificate[] x509Certificates,
					String s) throws java.security.cert.CertificateException {
			}

			public java.security.cert.X509Certificate[] getAcceptedIssuers() {
				return new java.security.cert.X509Certificate[0];
			}
		};
		SSLContext sslcontext = SSLContext.getInstance("TLS");

		sslcontext.init(null, new TrustManager[] { easyTrustManager }, null);
		SSLSocketFactory sf = new SSLSocketFactory(sslcontext);
		Scheme sch = new Scheme("https", 443, sf);
		httpClient.getConnectionManager().getSchemeRegistry().register(sch);
	}

	/**
	 * https post璇锋眰
	 * @param httpClient
	 * @param httpPost
	 * @param url
	 * @param params
	 * @return
	 * @throws RequestException
	 */
	public static String HttpPost(DefaultHttpClient httpClient, HttpPost httpPost, List<NameValuePair> params){
		try {
			httpPost.setEntity(new UrlEncodedFormEntity(params));
			HttpResponse response = httpClient.execute(httpPost);
			HttpEntity entity = response.getEntity();
			return EntityUtils.toString(entity);
		} catch (Exception e){
			e.printStackTrace();
		}
    return null;
	}
	
	/**
	 * 澶勭悊鐧诲綍
	 * 
	 * @param httpClient
	 * @throws UnsupportedEncodingException
	 * @throws IOException
	 * @throws ClientProtocolException
	 */
	public static String HttpPost(CloseableHttpClient httpClient, String url, List<NameValuePair> params)
			throws UnsupportedEncodingException, IOException,
			ClientProtocolException {
		HttpPost httppost = new HttpPost(url);

		httppost.setHeader("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
		httppost.setHeader("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
		httppost.setHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
		httppost.setHeader("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0");
		httppost.setEntity(new UrlEncodedFormEntity(params));
		HttpResponse response = httpClient.execute(httppost);
		HttpEntity entity = response.getEntity();

		return EntityUtils.toString(entity);
	}
	
	/**
	 * https get璇锋眰
	 * @param httpClient
	 * @param httpGet
	 * @return
	 * @throws RequestException
	 */
	public static String HttpGet(DefaultHttpClient httpClient, HttpGet httpGet){
		try {
			HttpResponse response = httpClient.execute(httpGet);
			HttpEntity entity = response.getEntity();
			return EntityUtils.toString(entity);
		} catch (Exception e){
			e.printStackTrace();
		}
    return null;
	}

	/**
	 * 澶勭悊鐧诲綍
	 * 
	 * @param httpClient
	 * @throws UnsupportedEncodingException
	 * @throws IOException
	 * @throws ClientProtocolException
	 */
	public static CloseableHttpResponse  HttpPostForHttpResponse(CloseableHttpClient httpClient, String url, List<NameValuePair> params)
			throws UnsupportedEncodingException, IOException,
			ClientProtocolException {
		HttpPost httppost = new HttpPost(url);

		httppost.setHeader("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
		httppost.setHeader("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
		httppost.setHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
		httppost.setHeader("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0");
		httppost.setEntity(new UrlEncodedFormEntity(params));

		return httpClient.execute(httppost);
	}

}
